unit hiExtIconEx;

interface

uses Windows,Kol,Share,Debug,ShellAPI;

type
  THIExtIconEx = class(TDebug)
   private
    ico:PIcon;
    fn:string;
    function GetFileIcon(Path: String; OpenIcon: Boolean): hIcon;
    function GetSmallIcon(Path: String; IconIndex: Integer): hIcon;
   public
    _prop_Index:integer;
    _prop_FileName:string;
    _prop_Transparent:TColor;
    _prop_SmallIcon:boolean;
    _prop_AssIcon:boolean;
    _event_onIcon:THI_Event;
    _event_onBMP:THI_Event;
    _event_onCount:THI_Event;
    _data_FileName:THI_Event;
    _data_Index:THI_Event;

    procedure _work_doExtIcon(var _Data:TData; Index:word);
    procedure _work_doTransparent(var _Data:TData; Index:word);
    procedure _work_doSmallIcon(var _Data:TData; Index:word);
    procedure _work_doCount(var _Data:TData; Index:word);
    procedure _var_Icon(var _Data:TData; Index:word);
    procedure _var_Count(var _Data:TData; Index:word);
  end;

implementation

function THIExtIconEx.GetFileIcon(Path: String; OpenIcon: Boolean): hIcon;
var Flags: Integer;
    SFI: TShFileInfo;
begin
if _prop_SmallIcon  
    then Flags:= SHGFI_ICON or SHGFI_ICONLOCATION or SHGFI_SMALLICON or SHGFI_TYPENAME or SHGFI_SYSICONINDEX
    else Flags:= SHGFI_ICON or SHGFI_ICONLOCATION or SHGFI_LARGEICON or SHGFI_TYPENAME or SHGFI_SYSICONINDEX;
//    if OpenIcon then Flags:= Flags or SHGFI_OPENICON;
//    FillChar(SFI, sizeof(SFI), 0); 
    ShGetFileInfo(PChar(Path), 0, SFI, SizeOf(SFI), Flags);
    Result:= SFI.hIcon; 
end;

function THIExtIconEx.GetSmallIcon(Path: String; IconIndex: Integer): hIcon;
var Licon,sIcon:hIcon;
begin
    ExtractIconEx(PChar(Path),IconIndex,Licon,sIcon,1);
    Result:= hIcon(sIcon); 
end;

procedure THIExtIconEx._work_doExtIcon;
var bmp:PBitmap;
    ind:word;
    ext:string;
    i:integer;
begin
    fn := ReadString(_Data,_data_FileName,_prop_FileName);
      if Assigned(ico) then ico.free;
       ico := NewIcon;
       ind := ReadInteger(_Data,_data_Index,_prop_Index); 

       if not _prop_AssIcon then 
         begin
          if _prop_SmallIcon then 
            begin
             ext := LowerCase(ExtractFileExt(fn));
               if ext = '.exe' then i:= 0 else 
               if ext = '.cpl' then i:= 0 else
               if ext = '.icl' then i:= 0 else
               if ext = '.dll' then i:= 0 else
               if ext = '.ocx' then i:= 0 else i:=1;
             case i of
               0:  ico.handle:= GetSmallIcon(fn,ind);
               1:  ico.handle:= GetFileIcon(fn,false);       
             end;          
            end
          else ico.handle := ExtractAssociatedIcon(hInstance,PChar(fn), ind)
         end
          else ico.handle:= GetFileIcon(fn,false);                

       if ico.Handle <> 0 then dtIcon(_Data,ico) else dtNull(_Data);
       _hi_onEvent(_event_onIcon,_Data);
     
    if Assigned(_event_onBMP.Event) then
      begin
       bmp := NewBitmap(0,0);
       bmp.Handle := Ico.Convert2Bitmap(_prop_Transparent);
       _hi_OnEvent(_event_onBMP,bmp);
       bmp.free;
      end;
end;

procedure THIExtIconEx._work_doCount;
var count:integer;
begin
     fn:=ReadString(_Data,_data_FileName,_prop_FileName);
     ico := NewIcon;
     count := -1;
     ico.handle := ExtractIcon(hInstance,PChar(fn),count);
     if ico.Handle <> 0 then dtInteger(_Data,ico.handle) else dtInteger(_Data,0);
     _hi_OnEvent(_event_onCount,Integer(ico.handle));
end;

procedure THIExtIconEx._var_Icon;
begin
   if ico <> nil then dtIcon(_Data,ico) else dtNull(_Data);
end;

procedure THIExtIconEx._var_Count;
begin
   if ico <> nil then dtInteger(_Data,ico.handle) else dtInteger(_Data,-1);   
end;

procedure THIExtIconEx._work_doTransparent;
begin
  _prop_Transparent := ToInteger(_Data);
end;

procedure THIExtIconEx._work_doSmallIcon;
begin
  _prop_SmallIcon := ReadBool(_Data);
end;

end.